

<?php 

/* Hichi IR */

$url = 'http://192.168.XXX.XXX/cm?cmnd=STATUS+8'; 
$curl = curl_init($url);

$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
$netz_error = '';

curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
$response = curl_exec($curl);
if($response === false) {
    $netz_error = curl_error($curl);

    $Power_cur = '';
    $Total_in_d = '';
    $Total_out_d = '';

} else {

    $data = json_decode($response, true);

    $Power_cur = $data['StatusSNS']['MT681']['Power_cur'];
    $Total_in = $data['StatusSNS']['MT681']['Total_in'];
    $Total_out = $data['StatusSNS']['MT681']['Total_out'];
    $Total_in_d = number_format($Total_in, 2);
    $Total_out_d = number_format($Total_out, 2);

}

curl_close($curl);

/* EZ-1 Wechselrichter */

$url = 'http://192.168.XXX.XXX:8050/getOutputData'; 
$curl = curl_init($url);

$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
$sun_error = '';

curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
$response = curl_exec($curl);

if($response === false) {
    $sun_error = curl_error($curl);

    $p = '';
    $e_d = '';
    $te_d = '';

} else {

    $data = json_decode($response, true);

    $p = $data['data']['p1'] + $data['data']['p2'];
    $e = $data['data']['e1'] + $data['data']['e2'];
    $e_d = number_format($e, 2);
    $te = $data['data']['te1'] + $data['data']['te2'];
    $te_d = number_format($te, 2);


}

curl_close($curl);

?>

<!doctype html>
<html lang="de">

<head>
    <title>Strom</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="robots" content="index, follow">
    <meta name="language" content="de">
    <meta http-equiv="refresh" content="300">

    <link rel="icon" href="assets/favicons/sun.svg" type="image/svg+xml">

    <link rel="stylesheet" type="text/css" href="assets/css/bootstrap-icons.css">
    <link rel="stylesheet" type="text/css" href="assets/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css" href="assets/css/styles.css">

</head>

<body>

<div class="container">
    <div class="row">

        <div class="col-12 pt-3 pt-md-5 mb-3 mb-md-4">
            <h3>Solar Power <span class="text-muted">local<span></h3>
         </div>

        <?php if ($sun_error){ ?>
         <div class="col-12 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Fehler</p>
                <p><?php echo $sun_error;?></p>
            </div>
         </div>
         <?php } ?>

        <div class="col-6 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Aktuell <?php //echo $lastreload; ?></p>
                <h1 class="text-center display-3 mb-0"><?php echo $p;?></h1>
                <p class="text-center">W</p>
            </div>
         </div>

         <div class="col-6 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Heute</p>
                <h1 class="text-center display-3 mb-0"><?php echo $e_d?></h1>
                <p class="text-center">kwh</p>
            </div>
         </div>

        <div class="d-none d-md-block col-12 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Gesamt</p>
                <h1 class="text-center display-3 mb-0"><?php echo $te_d;?></h1>
                <p class="text-center">kwh</p>
            </div>
         </div>
    </div>
</div>

<div class="container">
    <div class="row">

        <div class="col-12 pt-3 pt-md-5 mb-3 mb-md-4">
            <h3>Strom <span class="text-muted">lokal<span></h3>
         </div>

        <?php if ($netz_error){ ?>
         <div class="col-12 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Fehler</p>
                <p><?php echo $netz_error;?></p>
            </div>
         </div>
         <?php } ?>

        <div class="col-6 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Aktuell <?php //echo $lastreload; ?></p>
                <h1 class="text-center display-3 mb-0"><?php echo $Power_cur;?></h1>
                <p class="text-center">W</p>
            </div>
         </div>

         <div class="col-6 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Total in</p>
                <h1 class="text-center display-3 mb-0"><?php echo $Total_in_d?></h1>
                <p class="text-center">kwh</p>
            </div>
         </div>

        <div class="d-none d-md-block col-12 col-md-4 mb-4">
            <div class="box bg-white">
                <p class="text-muted small">Total out</p>
                <h1 class="text-center display-3 mb-0"><?php echo $Total_out_d;?></h1>
                <p class="text-center">kwh</p>
            </div>
         </div>
    </div>
</div>


    <script type="text/javascript" src="assets/js/jquery.js"></script>
    <script type="text/javascript" src="assets/js/bootstrap.min.js"></script>

    <script>

    var Total_in = <?php echo $Total_in; ?>;

    if (Total_in > 0){      

        $.post( "https://www.#######URL#######/newitem.php", { 
            secretkey: "jfs839howis39fso3ihdfs",
            Power_cur: "<?php echo $Power_cur; ?>", 
            Total_in: "<?php echo $Total_in; ?>", 
            Total_out: "<?php echo $Total_out; ?>",
            p: "<?php echo $p; ?>", 
            e: "<?php echo $e; ?>", 
            te: "<?php echo $te; ?>"  
        });

    }

    </script>

</body>

</html>